searchData={"content_type":"text/markdown","items":[{"doc":"","ref":"PlugImageProcessing.Info.html","title":"PlugImageProcessing.Info","type":"protocol"},{"doc":"","ref":"PlugImageProcessing.Info.html#process/1","title":"PlugImageProcessing.Info.process/1","type":"function"},{"doc":"","ref":"PlugImageProcessing.Info.html#t:t/0","title":"PlugImageProcessing.Info.t/0","type":"type"},{"doc":"","ref":"PlugImageProcessing.Middleware.html","title":"PlugImageProcessing.Middleware","type":"protocol"},{"doc":"","ref":"PlugImageProcessing.Middleware.html#enabled?/2","title":"PlugImageProcessing.Middleware.enabled?/2","type":"function"},{"doc":"","ref":"PlugImageProcessing.Middleware.html#run/2","title":"PlugImageProcessing.Middleware.run/2","type":"function"},{"doc":"","ref":"PlugImageProcessing.Middleware.html#t:t/0","title":"PlugImageProcessing.Middleware.t/0","type":"type"},{"doc":"","ref":"PlugImageProcessing.Operation.html","title":"PlugImageProcessing.Operation","type":"protocol"},{"doc":"","ref":"PlugImageProcessing.Operation.html#process/2","title":"PlugImageProcessing.Operation.process/2","type":"function"},{"doc":"","ref":"PlugImageProcessing.Operation.html#valid?/1","title":"PlugImageProcessing.Operation.valid?/1","type":"function"},{"doc":"","ref":"PlugImageProcessing.Operation.html#t:t/0","title":"PlugImageProcessing.Operation.t/0","type":"type"},{"doc":"","ref":"PlugImageProcessing.Source.html","title":"PlugImageProcessing.Source","type":"protocol"},{"doc":"","ref":"PlugImageProcessing.Source.html#cast/2","title":"PlugImageProcessing.Source.cast/2","type":"function"},{"doc":"","ref":"PlugImageProcessing.Source.html#get_image/3","title":"PlugImageProcessing.Source.get_image/3","type":"function"},{"doc":"","ref":"PlugImageProcessing.Source.html#t:t/0","title":"PlugImageProcessing.Source.t/0","type":"type"},{"doc":"Image server as a   Plug  , powered by   libvips  .","ref":"readme.html","title":"README","type":"extras"},{"doc":"","ref":"readme.html#usage","title":"Usage - README","type":"extras"},{"doc":"PlugImageProcessing is published on Hex. Add it to your list of dependencies in `mix.exs`:\n\n```elixir\n# mix.exs\ndef deps do\n  [\n    {:plug_image_processing, \">= 0.0.1\"}\n  ]\nend\n```\n\nThen run mix deps.get to install the package and its dependencies.\n\nTo expose a `/imageproxy` route, add the plug in your endpoint, before your router plug, but after `Plug.Parsers`:\n\n```elixir\n# lib/my_app_web/endpoint.ex\nplug(PlugImageProcessing.Web, path: \"/imageproxy\")\n#...\nplug(MyAppWeb.Router)\n```","ref":"readme.html#installation","title":"Installation - README","type":"extras"},{"doc":"","ref":"readme.html#features","title":"Features - README","type":"extras"},{"doc":"A single source for image is supported for now: the `url` query parameter.\n\n```sh\n/imageproxy/resize?url=https://s3.ca-central-1.amazonaws.com/my_image.jpg&width=300\n```\n\nIt will download the image from the remote location, modify it using libvips and return it to the client.","ref":"readme.html#sources","title":"Sources - README","type":"extras"},{"doc":"A number of operations exposed by libvips are supported by `PlugImageProcessing`. See the `PlugImageProcessing.Operations.*` module for more details.","ref":"readme.html#operations","title":"Operations - README","type":"extras"},{"doc":"Validations can be added so your endpoint is more secure.","ref":"readme.html#requests-validations","title":"Requests validations - README","type":"extras"},{"doc":"By adding a signature key in your config, a parameter `sign` needs to be included in the URL to validate the payload.\nThe signature prevent a client to forge a large number of unique requests that would go through the CDN and hitting our server.\n\n```elixir\nplug(PlugImageProcessing.Web, url_signature_key: \"1234\")\n```\n\nThen a request path like:\n\n```sh\n/imageproxy/resize?url=https://s3.ca-central-1.amazonaws.com/my_image.jpg&width=300&quality=60\n```\n\nwill fail because the `sign` parameter is not present.\n\n**The HMAC-SHA256 hash is created by taking the URL path (excluding the leading /), the request parameters (alphabetically-sorted and concatenated with & into a string). The hash is then base64url-encoded.**\n\n```elixir\nBase.url_encode64(:crypto.mac(:hmac, :sha256, \"1234\", \"resize\" <> \"quality=60&url=https://s3.ca-central-1.amazonaws.com/my_image.jpg&width=300\"))\n# => \"ku5SCH56vrsqEr-_VRDOFJHqa6AXslh3fpAelPAPoeI=\"\n```\n\nNow this request will succeed!\n\n```sh\n/imageproxy/resize?url=https://s3.ca-central-1.amazonaws.com/my_image.jpg&width=300&quality=60&sign=ku5SCH56vrsqEr-_VRDOFJHqa6AXslh3fpAelPAPoeI=\n```","ref":"readme.html#signature-key","title":"Signature key - README","type":"extras"},{"doc":"`PlugImageProcessing` is © 2022 [Mirego](https://www.mirego.com) and may be freely distributed under the [New BSD license](http://opensource.org/licenses/BSD-3-Clause). See the [`LICENSE.md`](https://github.com/mirego/plug_image_processing/blob/master/LICENSE.md) file.","ref":"readme.html#license","title":"License - README","type":"extras"},{"doc":"[Mirego](https://www.mirego.com) is a team of passionate people who believe that work is a place where you can innovate and have fun. We’re a team of [talented people](https://life.mirego.com) who imagine and build beautiful Web and mobile applications. We come together to share ideas and [change the world](http://www.mirego.org).\n\nWe also [love open-source software](https://open.mirego.com) and we try to give back to the community as much as we can.","ref":"readme.html#about-mirego","title":"About Mirego - README","type":"extras"}],"producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}